
#include "producer_consumer.h"


int semid;
int shmid;

int removed_item = 0;

struct sembuf sops[SEM_NUM];

int main() {

    /*--- pointer auf Shared Memory, erhlt man von shmat() ---*/
    prod_con_shm_t *shmPtr;

    size_t len;
    char myString[MY_STRING_LEN];

    /*--- Erzeugung des Shm, falls noch nicht vorhanden,
          Rueckgabe ist die Shared Memory Id (vergleichbar
          mit Dateideskriptor ---*/ 
    if ( 0 > ( shmid = shmget(SHM_KEY,
                              sizeof(prod_con_shm_t),
                              (IPC_CREAT | SHM_PERM)) ) ) {
       perror("consumer: problem with shmget()");
       exit(1);
    }


    /*--- shmat() bildet das Shared Memory in den
          lokalen Adressraum ab, Anfangsadresse
          liegt auf dem Rueckgabewert shmPtr ---*/ 
    if ( 0 > ( shmPtr = shmat(shmid,0,0) ) ) {
       perror("consumer: problem with shmat()");
       exit(1);
    }

    printf("POINTER VALUE shmPtr %04X \n",(int)shmPtr);



    /*--- Consumer Schleife ---*/ 
    strcpy(myString,"START");

    while( strcmp(myString,"END") ) {

	do { len = MY_STRING_LEN; } 
        while ( getRb(shmPtr,(void *)myString, &len) );


	myString[MY_STRING_LEN-1] = 0;
	printf("CONSUMER: %s\n");

    }

    exit(0);

}





