#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

#define MY_STRING_LEN 1000

#define SHM_PERM 0777
#define SHM_KEY 0x2A

/*--- Semaphore key ---*/
#define SEM_KEY 0x2A
#define SEM_NUM 3
#define SEM_PERM 0777

#define SEM_MUTEX 0
#define SEM_EMPTY 1
#define SEM_FULL  2

#define BUFFER_SIZE 5


typedef struct {

    size_t len;
    char   b[MY_STRING_LEN];

} data_t;



typedef struct {
    
    /*--- read Index ---*/
    int r;
    /*--- write Index ---*/
    int w;

    /*--- Buffer containing pointers to variable length
      data messages ---*/
    data_t buffer[BUFFER_SIZE];

} prod_con_shm_t;


extern void initRb(prod_con_shm_t *shmPtr);

extern int putRb(prod_con_shm_t *shmPtr, void *b, size_t len);

extern int getRb(prod_con_shm_t *shmPtr, void *b, size_t *len);
