#include "producer_consumer.h"


void initRb(prod_con_shm_t *shmPtr) {

    if ( shmPtr ) {
	shmPtr->r = shmPtr->w = 0;
    }

}


int putRb(prod_con_shm_t *shmPtr, void *b, size_t len) {

    int retcode = -1;
    int wnext;

    if ( shmPtr ) {
	
	wnext = (shmPtr->w + 1)%BUFFER_SIZE;

	if ( wnext != shmPtr->r ) {

	    if ( len > MY_STRING_LEN ) len = MY_STRING_LEN;

            shmPtr->buffer[shmPtr->w].len = len;
	    memcpy(shmPtr->buffer[shmPtr->w].b,b,len);
	    shmPtr->w = wnext;
	    retcode = 0;

	}

    }

    return retcode;

}


int getRb(prod_con_shm_t *shmPtr, void *b, size_t *len) {

    int retcode = -1;

    if ( 0 < *len 
         && shmPtr
         && shmPtr->r != shmPtr->w ) {

	if ( shmPtr->buffer[shmPtr->r].len < *len )
	    *len = shmPtr->buffer[shmPtr->r].len;

	memcpy(b,shmPtr->buffer[shmPtr->r].b,*len);

	shmPtr->r = (shmPtr->r + 1)%BUFFER_SIZE;

	retcode = 0;

    }

    return retcode;

}
